#include <bits/stdc++.h>

using namespace std;

int n;
int k;
int a[500005];
bool obrisano[500005];
//0-rastuci
//1-opadajuci
//2-neutralni
int l,r;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    cin >> n >> k;

    for(int i=1;i<=n;i++)
    {
        cin >> a[i];
    }

    if(n==1)
    {
       cout << a[1];
       return 0;
    }

    int left=k;

    for(int i=2;i<=n && left>0;i++)
    {
        if(a[i]<a[i-1])
        {
            obrisano[i-1]=true;
            left--;
        }
    }

    if(left>0)
    {
        vector<pair<int,int> > v;
        for(int i=1;i<=n;i++)
        {
            if(!obrisano[i]) v.push_back({a[i],i});
        }

        sort(v.begin(),v.end());

        for(int i=v.size()-1;i>=0 && left>0;i--)
        {
            obrisano[v[i].second]=true;
        }
    }
        for(int i=1;i<=n;i++)
        {
            if(!obrisano[i]) cout << a[i] << " ";
        }

    return 0;
}